; ------------------------------------------------------
; OpenGL framework
; Copyright (c) 2005, Franck Charlet
; All rights reserved.
; ------------------------------------------------------

.586
.mmx
.xmm
			.model	flat,stdcall
			option	casemap:none

; ------------------------------------------------------
; Includes
			include windows.inc
			include kernel32.inc
			include user32.inc
			include gdi32.inc
            include ole32.inc
			include oleaut32.inc

			include gl.inc
			include glext.inc
			include glati.inc
			include glu.inc
			include wingdi.inc
			include wglati.inc
			include wglext.inc
			include msvcrt.inc
			include dinput.inc
			include glm.inc
			include Quaternions.inc
			include IPicture.inc
DIRECTSOUND_VERSION	equ	00900h
			include dsound.inc

			includelib kernel32.lib
			includelib user32.lib
			includelib gdi32.lib
			includelib opengl32.lib
			includelib glu32.lib
			includelib dinput.lib
			includelib ole32.lib
			includelib oleaut32.lib
			includelib dsound.lib
			
			includelib msvcrt.lib
			includelib dxguid.lib
			includelib dinput8.lib
			includelib glm.lib
			includelib Quaternions.lib

; ------------------------------------------------------
; Constants
ifndef DM_BITSPERPEL
DM_BITSPERPEL		equ	000040000h
endif
ifndef DM_PELSWIDTH
DM_PELSWIDTH		equ	000080000h
endif
ifndef DM_PELSHEIGHT
DM_PELSHEIGHT		equ	000100000h
endif
ifndef DM_DISPLAYFREQUENCY
DM_DISPLAYFREQUENCY	equ	000400000h
endif
ifndef CDS_FULLSCREEN
CDS_FULLSCREEN		equ	000000004h
endif
ifndef ANTIALIASED_QUALITY
ANTIALIASED_QUALITY	equ	4
endif
ifndef PFD_DRAW_TO_WINDOW
PFD_DRAW_TO_WINDOW	equ	00000004h
endif
ifndef PFD_SUPPORT_OPENGL
PFD_SUPPORT_OPENGL	equ	00000020h
endif
ifndef PFD_DOUBLEBUFFER
PFD_DOUBLEBUFFER	equ	00000001h
endif
ifndef PFD_SWAP_EXCHANGE
PFD_SWAP_EXCHANGE	equ	00000200h
endif
ifndef PFD_TYPE_RGBA
PFD_TYPE_RGBA		equ	0
endif

PFD_DRAW_TO_BITMAP equ 8
PFD_MAIN_PLANE		equ	0
PFD_TYPE_COLORINDEX	equ	1
PFD_TYPE_RGBA		equ	0
PFD_DOUBLEBUFFER	equ	1
PFD_DRAW_TO_WINDOW	equ	4
PFD_SUPPORT_OPENGL	equ	020h
PFD_SUPPORT_GDI	equ 16

; ------------------------------------------------------
; Macros
literal_float		macro	lit_float
			local	local_float

			.data
local_float		real4	lit_float

			.code
			exitm	<local_float>
			endm

CFLT			macro	lit_float
			exitm	<literal_float(lit_float)>
			endm

INT2FLT			macro	lit_float
			local	local_int_float

			.data
local_int_float		real4	0.0

			.code
			push	lit_float
			fild	dword ptr [esp]
			add	esp,4
			fstp	dword ptr [local_int_float]
			exitm	<local_int_float>
			endm

FLT2INT			macro	float_lit
			local	local_float_int

			.data
local_float_int		dd	0

			.code
			push	float_lit
			fld	dword ptr [esp]
			add	esp,4
			fistp	dword ptr [local_float_int]
			exitm	<local_float_int>
			endm

ALLOCMEM		macro	_Size
			invoke	GlobalAlloc, GMEM_ZEROINIT or GMEM_FIXED, _Size
			exitm	<eax>
			endm

FREEMEM			macro	Datas
			.if	Datas != NULL
				invoke	GlobalFree, Datas
			.endif
			endm

CMEM			macro	_Datas
			mov	eax,_Datas
			exitm	<eax>
			endm

INT2DBL			macro	lit_double
			local	local_int_double

			.data
local_int_double	real8	0.0

			.code
			push	lit_double
			fild	dword ptr [esp]
			add	esp,4
			fstp	qword ptr [local_int_double]
			exitm	<local_int_double>
			endm

literal_double		macro	lit_double
			local	local_double

			.data
local_double		real8	lit_double

			.code
			exitm	<local_double>
			endm

CDBL			macro	lit_double
			exitm	<literal_double(lit_double)>
			endm

literal_string		macro	lit_string
			local	local_string

			.data
local_string		db	lit_string,0

			.code
			exitm	<local_string>
			endm

CSTR			macro	lit_string
			exitm	<offset literal_string(lit_string)>
			endm

FCMP			macro	Float1, Float2
			fld	Float1
			fcomp	Float2
			fnstsw	ax
			sahf
			endm

FCMP0			macro	Float
			fld	Float
			ftst
			fnstsw	ax
			sahf
			fstp	st(0)
			endm

; ------------------------------------------------------
; Structures
APPLICATION		struct
hInstance		dword	?
APPLICATION		ends

GL_WINDOWINIT		struct
application		APPLICATION <>
winwidth		dword	?
winheight		dword	?
bitsPerPixel		dword	?
GL_WINDOWINIT		ends

GL_WINDOW		struct
hWnd			dword	?
hDC			dword	?
hRC			dword	?
init			GL_WINDOWINIT <>
isVisible		dword	?
LastTickCount		LONGLONG ?
GL_WINDOW		ends

CreateLayerOGL proto
Get_Frames_Delay	proto

; ------------------------------------------------------
; Variables
			.data
g_Error_Message		dd	0
g_window		GL_WINDOW <>
g_FullScreen		dd	0
g_CursorState		dd	0
g_NoSwap		dd	FALSE
g_Screen_Frequency	dd	0

_ClassName		db	"OGLW",0
_WindowName		db	"OGL Windows",0
_PixelFormat		dd	0
_hBrush			dd	0
_AntiAliasing		dd	0
_VSync			dd	TRUE
_Do_AntiAliasing	dd	0
_Frames_Seconds		real4	0.0
_Frames_Counter		dd	0
_Frames_Count		dd	0
_Title_FPS		db	32 dup (0)
_dmScreenSettings	DEVMODE	<>
wglChoosePixelFormatARB	PFNWGLCHOOSEPIXELFORMATARBPROC 0
_Nbr_Sampling_Formats	dd	0
_Format_fAttributes	real4	0.0, 0.0
_Format_iAttributes	dd	WGL_DRAW_TO_WINDOW_ARB, TRUE
			dd	WGL_SUPPORT_OPENGL_ARB, TRUE
			dd	WGL_ACCELERATION_ARB, WGL_FULL_ACCELERATION_ARB
			dd	WGL_COLOR_BITS_ARB
_Format_Color_Bits	dd	24
			dd	WGL_ALPHA_BITS_ARB
_Format_Alpha_Bits	dd	8
			dd	WGL_DEPTH_BITS_ARB
_Format_Depth_Bits	dd	16
			dd	WGL_STENCIL_BITS_ARB
_Format_Stencil_Bits	dd	0
			dd	WGL_DOUBLE_BUFFER_ARB, TRUE
			dd	WGL_SAMPLE_BUFFERS_ARB, TRUE
			dd	WGL_SAMPLES_ARB
_Format_Multi_Samples	dd	4
			dd	0, 0

_SubEditBrush		LOGBRUSH <BS_SOLID, 0, 0>
_wtop			dd	0
_wleft			dd	0
_Flt0001		real4	0.001
_Flt05			real4	0.5
_Flt255			real4	255.0
_Flt2			real4	2.0
_Fltm2			real4	-2.0
_Flt1			real4	1.0
_Fltm1			real4	-1.0
_fH			real8	0.0049999998882413
_zNear			real8	0.01
_zFar			real8	500.0
pwglSwapIntervalEXT	PFNWGLSWAPINTERVALEXTPROC 0
pfd			PIXELFORMATDESCRIPTOR <	sizeof PIXELFORMATDESCRIPTOR, \
						1, \
						PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_SWAP_EXCHANGE, \
						PFD_TYPE_RGBA, \
						0, \
						0, 0, 0, 0, 0, 0, \
						0, \
						0, \
						0, \
						0, 0, 0, 0, \
						24, \
						0, \
						0, \
						0, \
						0, \
						0, 0, 0 >

			align	4		; Required by Performance Counter
HTimerFreq		LONGLONG 0
HTimerVal		LARGE_INTEGER <>

   ClassName db "GEF",0
   AppName  db "GEF-F.C",0
   hWin dword ?
   wDC dword ?
.data?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?
; ------------------------------------------------------
; Public functions
Terminate_Application	proto
Initialize		proto
Deinitialize		proto
Update			proto	:dword
Draw			proto
Set_Frames_Counter	proto
Get_Frames_Delay	proto
Set_Error_Msg		proto	:dword
Reshape_Context		proto	:dword, :dword
Get_Pixel_Format	proto
Set_VSync		proto	:dword
RefreshScreen proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

			include	DInput.asm
			include Extensions.asm
			include Dialog.asm
; ------------------------------------------------------
; Name: Terminate_Application
; Desc: Initiate termination procedure
Terminate_Application	proc
			invoke	PostMessage, g_window.hWnd, WM_QUIT, 0, 0
			ret
Terminate_Application	endp

; ------------------------------------------------------
; Name: Flush_Event
; Desc: Flush the pending messages
Flush_Event		proc
			local	msg:MSG
			
			invoke	PeekMessage, addr msg, NULL, 0, 0, PM_REMOVE
			.if eax != 0
				invoke	DispatchMessage, addr msg
			.endif
			ret
Flush_Event		endp

; ------------------------------------------------------
; Name: Change_Screen_Resolution
; Desc: Resize the screen with given dimensions and depth
Change_Screen_Resolution proc	w:dword, h:dword, bitsPerPixel:dword
			invoke	RtlZeroMemory, addr _dmScreenSettings, sizeof DEVMODE
			mov	_dmScreenSettings.dmSize, sizeof DEVMODE
			mov	_dmScreenSettings.dmPelsWidth, CMEM(w)
			mov	_dmScreenSettings.dmPelsHeight, CMEM(h)
			mov	_dmScreenSettings.dmBitsPerPel, CMEM(bitsPerPixel)
			mov	_dmScreenSettings.dmFields, DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT or DM_DISPLAYFREQUENCY
			mov	_dmScreenSettings.dmDisplayFrequency, 60
			invoke	ChangeDisplaySettings, addr _dmScreenSettings, CDS_FULLSCREEN
			.if	eax != DISP_CHANGE_SUCCESSFUL
				xor	eax, eax
			.else
				mov	eax, TRUE
			.endif
			ret
Change_Screen_Resolution endp

; -----------------------------------------------------------------------
; Name: Get_Current_Frequency
; Desc: Retrieve the monitor frequency set by the user
Get_Current_Frequency	proc
			invoke	EnumDisplaySettings, NULL, ENUM_CURRENT_SETTINGS, addr _dmScreenSettings
			mov	eax, _dmScreenSettings.dmDisplayFrequency
			mov	g_Screen_Frequency, eax
			ret
Get_Current_Frequency	endp

; -----------------------------------------------------------------------
; Name: WindowProc
; Desc: Messages handler for the main window
WindowProc		proc	hWnd:dword, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
			local	creation:CREATESTRUCT
			
			.if	uMsg == WM_SYSCOMMAND
				.if	wParam == SC_SCREENSAVE || wParam == SC_MONITORPOWER
					xor	eax, eax
					ret
				.endif
			.elseif uMsg == WM_DISPLAYCHANGE
				invoke	Get_Current_Frequency
			.elseif	uMsg == WM_CLOSE
				invoke	Terminate_Application
				xor	eax, eax
				ret
			.elseif	uMsg == WM_ACTIVATE
				.if	g_FullScreen != FALSE
					mov	eax, wParam
					and	eax, 0ffffh
					mov	ecx, eax
					and	eax, WA_ACTIVE
					and	ecx, WA_CLICKACTIVE
					.if	eax != 0 || ecx != 0
						invoke	Change_Screen_Resolution, g_window.init.winwidth, g_window.init.winheight, g_window.init.bitsPerPixel
						invoke	GetSystemMetrics, SM_CXSCREEN
						push	eax
						invoke	GetSystemMetrics, SM_CYSCREEN
						mov	ecx, eax
						pop	eax
						invoke	SetWindowPos, hWnd, HWND_TOPMOST, 0, 0, eax, ecx, SWP_SHOWWINDOW
						invoke	Input_GotFocus
						mov	g_window.isVisible,TRUE
					.else
						invoke	ChangeDisplaySettings, NULL, 0
						invoke	SetWindowPos, hWnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_SHOWWINDOW
						invoke	ShowWindow,hWnd, SW_MINIMIZE
						invoke	Input_LostFocus
						mov	g_window.isVisible,FALSE
					.endif
				.endif
			.elseif	uMsg == WM_SIZE
				.if	wParam == SIZE_MINIMIZED
					invoke	Input_LostFocus
					mov	g_window.isVisible,FALSE
				.elseif	wParam == SIZE_MAXIMIZED || wParam == SIZE_RESTORED
					invoke	Input_GotFocus
					mov	g_window.isVisible,TRUE
				.endif
			.elseif	uMsg == WM_MOUSEMOVE
				.if	g_CursorState == TRUE
					mov	g_CursorState, FALSE
					invoke	ShowCursor, FALSE
				.endif
			.elseif	uMsg == WM_NCMOUSEMOVE
				.if	g_CursorState == FALSE
					mov	g_CursorState, TRUE
					invoke	ShowCursor, TRUE
				.endif
			.endif
			invoke	DefWindowProc, hWnd, uMsg, wParam, lParam
			ret
WindowProc		endp

; -----------------------------------------------------------------------
; Name: Main
; Desc: Program entry point
Main			proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG 
	
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW\
           ,0,\
           0,600,480,NULL,NULL,\
           hInst,NULL
	mov   hWin,eax
	
	invoke ShowWindow, hWin,SW_SHOWNORMAL
	invoke UpdateWindow, hWin
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
Main			endp

WndProc proc uses esi edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL tid8,tid16,tid32,tid64,tid128:dword
	LOCAL t[256]:dword
	LOCAL t2[256]:dword
	LOCAL buff[256]:dword
	LOCAL pic_pntr:dword
	LOCAL r:RECT
	local	windowStyle:dword
	
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		invoke GetDC,hWnd
		mov wDC,eax
		invoke CreateLayerOGL
;		.if	_AntiAliasing == TRUE
   				invoke	glEnable, GL_MULTISAMPLE_ARB
;		.endif
;		.if	_VSync == TRUE
			; Turn vsync ON
			invoke	Set_VSync, TRUE
;		.else
			; Turn vsync OFF
;			invoke	Set_VSync, FALSE
;		.endif

		invoke	wglGetProcAddress, CSTR("wglSwapIntervalEXT")
    	mov	pwglSwapIntervalEXT, eax
   		invoke Initialize
		invoke SetTimer,hWnd,1,1000/20,addr RefreshScreen
		
	.elseif uMsg==WM_SIZE
			invoke GetWindowRect,hWnd,addr r
			invoke Reshape_Context,r.right,r.bottom
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	
	xor eax,eax
	ret
WndProc endp

; Name: 
; Desc: Creating OpenGL screen
; Author: Onan Farabi
CreateLayerOGL proc
	LOCAL PF:PIXELFORMATDESCRIPTOR
	LOCAL dDC,PFH,OpenDC,dBmp:Dword
	
	mov PF.nSize,sizeof PF
	mov PF.nVersion,1
	mov	PF.dwFlags,PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL  or PFD_DOUBLEBUFFER
	mov	PF.dwLayerMask,PFD_MAIN_PLANE
	mov	PF.iPixelType,PFD_TYPE_RGBA
	mov	PF.cColorBits,8
	mov	PF.cDepthBits,16
	mov	PF.cAccumBits,0
	mov	PF.cStencilBits,0
	
	invoke ChoosePixelFormat,wDC,addr PF
	mov PFH,eax
	invoke SetPixelFormat,wDC,PFH,addr PF
	or eax,eax
	jz error

	
	invoke wglCreateContext,wDC
	mov OpenDC,eax
	invoke wglMakeCurrent,wDC,eax
	
	mov edx,wDC
	mov eax,OpenDC
	
	pushad
		invoke	wglGetProcAddress, CSTR("wglSwapIntervalEXT")
	    mov	pwglSwapIntervalEXT, eax
	    invoke	glEnable, GL_MULTISAMPLE_ARB
		; Turn vsync ON
		invoke	Set_VSync, TRUE
	popad
	ret
	error:
	xor eax,eax
	dec eax
	ret
CreateLayerOGL endp

; ------------------------------------------------------
; Name: Set_Frames_Counter
; Desc: Init the frames counter
Set_Frames_Counter	proc
			invoke	QueryPerformanceFrequency, addr HTimerVal
			fild	HTimerVal.QuadPart
			;fmul	_Flt0001
			fistp	HTimerFreq
			invoke	QueryPerformanceCounter, addr HTimerVal
			fild	HTimerVal.QuadPart
			fistp	g_window.LastTickCount
			ret
Set_Frames_Counter	endp

; ------------------------------------------------------
; Name: Get_Frames_Delay
; Desc: Amount of milliseconds between 2 frames
Get_Frames_Delay	proc
			local	Delay:real4

			invoke	QueryPerformanceCounter, addr HTimerVal
			fild	HTimerVal.QuadPart
			fild	g_window.LastTickCount
			fsubp	st(1), st(0)
			fild	HTimerFreq
			fdivp	st(1), st(0)
			;fmul	_Flt0001
			fstp	Delay
			fild	HTimerVal.QuadPart
			fistp	g_window.LastTickCount
			fld	Delay
			ret
Get_Frames_Delay	endp

; ------------------------------------------------------
; Name: Set_Error_Msg
; Desc: Load the g_Error_Message variable
Set_Error_Msg		proc	Msg:dword
			mov	eax, Msg
			mov	g_Error_Message, eax
			ret
Set_Error_Msg		endp

; ------------------------------------------------------
; Name: Set_VSync
; Desc: Turn vertical synchro on/off
Set_VSync		proc	Status:dword
    			.if	pwglSwapIntervalEXT != NULL
    				invoke	pwglSwapIntervalEXT, Status
    			.endif
    			ret
Set_VSync		endp

; ------------------------------------------------------
; Name: Reshape_GL
; Desc: Resize the opengl frame according to the screen/window's one
Reshape_Context		proc	_Width:dword, Height:dword
			local	_fW:real8
			local	_mfW:real8
			local	_mfH:real8

			; Set the projection matrix
			invoke	glViewport, 0, 0, _Width, Height
			invoke	glMatrixMode, GL_PROJECTION
			invoke	glLoadIdentity
			fld	qword ptr [_fH]
			fld	st(0)
			fchs
			fstp	qword ptr [_mfH]
			fild	dword ptr [_Width]
			fidiv	dword ptr [Height]
			fmulp	st(1),st(0)
			fst	qword ptr [_fW]
			fchs
			fstp	qword ptr [_mfW]
			invoke	glFrustum, _mfW, _fW, _mfH, _fH, _zNear, _zFar
			invoke	glMatrixMode, GL_MODELVIEW
			invoke	glLoadIdentity
			ret
Reshape_Context		endp

; ------------------------------------------------------
; Name: Get_Pixel_Format
; Desc: Obtain a suitable pixel format
Get_Pixel_Format	proc
			local	PixelFormat:dword

			.if	_AntiAliasing == TRUE
				movzx	eax, pfd.cColorBits
				mov	_Format_Color_Bits, eax
				movzx	eax, pfd.cAlphaBits
				mov	_Format_Alpha_Bits, eax
				movzx	eax, pfd.cDepthBits
				mov	_Format_Depth_Bits, eax
				movzx	eax, pfd.cStencilBits
				mov	_Format_Stencil_Bits, eax
				invoke	wglChoosePixelFormatARB, g_window.hDC, addr _Format_iAttributes, addr _Format_fAttributes, 1, addr PixelFormat, addr _Nbr_Sampling_Formats
				.if	eax == TRUE && _Nbr_Sampling_Formats >= 1
					mov	eax, PixelFormat
				.else
Try_Sampling:				; Try lower sampling until we reach a suitable level
					sub	_Format_Multi_Samples, 2
					invoke	wglChoosePixelFormatARB, g_window.hDC, addr _Format_iAttributes, addr _Format_fAttributes, 1, addr PixelFormat, addr _Nbr_Sampling_Formats
					.if	eax == TRUE && _Nbr_Sampling_Formats >= 1
						mov	eax, PixelFormat
					.else
						.if	_Format_Multi_Samples <= 2
							; No anti-aliasing
							invoke	ChoosePixelFormat, g_window.hDC, addr pfd
							mov	_AntiAliasing, FALSE
						.else
							jmp	Try_Sampling
						.endif
					.endif
				.endif
			.else 
				; (ChoosePixelFormat returns the pixel format in eax)
				invoke	ChoosePixelFormat, g_window.hDC, addr pfd
				mov	_AntiAliasing, FALSE
			.endif
			ret
Get_Pixel_Format	endp

; ------------------------------------------------------
; Name: Calc_FPS
; Desc: Calculate the number of frame per second
Calc_FPS		proc	FrameRate:real4
			.if	g_FullScreen == 0
				fld	FrameRate
				fadd	_Frames_Seconds
				fstp	_Frames_Seconds
				inc	_Frames_Counter
				FCMP	_Frames_Seconds, CFLT(1.0)		; Refresh it every second
				jb	Wait_Fps
				; Save the number of frames
				push	_Frames_Counter
				pop	_Frames_Count
				mov	_Frames_Seconds, 0
				mov	_Frames_Counter, 0
			.endif
Wait_Fps:		mov	eax, _Frames_Count
			ret
Calc_FPS		endp

PERR	PROC uses ebx edi esi	;, _API : DWORD
LOCAL	szMsgBuf[500]:BYTE

	INVOKE GetLastError
	mov	ebx, eax
	INVOKE FormatMessage, \
		FORMAT_MESSAGE_FROM_SYSTEM,\
		NULL, \
		ebx, \					;Message Id
		LANG_NEUTRAL + SUBLANG_DEFAULT*1024, \	;Message language
		ADDR szMsgBuf, \			;Buffer to store message
		500, \					;Buffer size
		NULL					;No more arguments
	INVOKE	MessageBox, NULL, ADDR szMsgBuf, NULL, MB_OK

	;INVOKE	ExitProcess, -1

	ret

PERR	ENDP

RefreshScreen proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL frame_delay:dword
	
;	invoke Get_Frames_Delay
	invoke Update,frame_delay
	invoke Draw
	invoke SwapBuffers,wDC
	ret
RefreshScreen endp
; ------------------------------------------------------
; Name: start
; Desc: Start of the program
start:	invoke GetModuleHandle, NULL
		mov    hInstance,eax
	
		invoke GetCommandLine
		mov    CommandLine,eax
				
		invoke Main, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax